diff --git a/src/backend/commands/vacuum.c b/src/backend/commands/vacuum.c
new file mode 100644
index 4cb4acf..8ba6bd6
*** a/src/backend/commands/vacuum.c
--- b/src/backend/commands/vacuum.c
*************** vac_truncate_clog(TransactionId frozenXI
*** 1050,1056 ****
  				  TransactionId lastSaneFrozenXid,
  				  MultiXactId lastSaneMinMulti)
  {
! 	TransactionId myXID = GetCurrentTransactionId();
  	Relation	relation;
  	HeapScanDesc scan;
  	HeapTuple	tuple;
--- 1050,1056 ----
  				  TransactionId lastSaneFrozenXid,
  				  MultiXactId lastSaneMinMulti)
  {
! 	TransactionId nextXID = ShmemVariableCache->nextXid;
  	Relation	relation;
  	HeapScanDesc scan;
  	HeapTuple	tuple;
*************** vac_truncate_clog(TransactionId frozenXI
*** 1099,1105 ****
  			MultiXactIdPrecedes(lastSaneMinMulti, dbform->datminmxid))
  			bogus = true;
  
! 		if (TransactionIdPrecedes(myXID, dbform->datfrozenxid))
  			frozenAlreadyWrapped = true;
  		else if (TransactionIdPrecedes(dbform->datfrozenxid, frozenXID))
  		{
--- 1099,1105 ----
  			MultiXactIdPrecedes(lastSaneMinMulti, dbform->datminmxid))
  			bogus = true;
  
! 		if (TransactionIdPrecedes(nextXID, dbform->datfrozenxid))
  			frozenAlreadyWrapped = true;
  		else if (TransactionIdPrecedes(dbform->datfrozenxid, frozenXID))
  		{
